import { Logger, LoggerLevel } from './../libs/logger';
import { Element } from './element.interface';
import { RootScene } from './root-scene';
import { Scene } from './scene/scene';
import { VarsProps } from './vars/vars.props';
export type ElementShadowClass = new (props?: any) => ElementShadow;
export type ElementClass = new (props?: any) => Element;
export declare abstract class ElementShadow implements Element {
    $$ignoreEvalProps: string[];
    title?: string;
    skip?: boolean;
    force?: boolean;
    error?: any;
    log?: LoggerLevel;
    vars?: VarsProps;
    async?: boolean;
    loop?: string;
    loopKey?: any;
    loopValue?: any;
    if?: any;
    $$tag: string;
    parentState?: Record<string, any>;
    parent?: ElementShadow;
    result?: any;
    logger: Logger;
    scene: Scene;
    rootScene: RootScene;
    get $$loggerLevel(): LoggerLevel;
    asyncConstructor(_props?: any): void;
    getParentByClassName<T extends ElementShadow>(...ClazzTypes: Array<new (...args: any[]) => ElementShadow>): T;
    setVarsAfterExec(): Promise<void>;
    evalPropsBeforeExec(): Promise<void>;
    callFunctionScript(script: string, ctx?: ElementShadow, others?: Record<string, any>): Promise<any>;
    abstract exec(input?: Record<string, any>): Promise<any>;
    dispose(): any;
    disposeApp?: () => any;
}
export declare function copyElementShadowPrototype(elem: any): void;
