"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExecJs = void 0;
const assert_1 = __importDefault(require("assert"));
const file_remote_1 = require("../../libs/file-remote");
const element_shadow_1 = require("../element-shadow");
class ExecJs extends element_shadow_1.ElementShadow {
    $$ignoreEvalProps = ['script'];
    script;
    path;
    constructor(props) {
        super();
        if (typeof props === 'string') {
            props = {
                script: props
            };
        }
        Object.assign(this, props);
    }
    async exec() {
        if (this.path) {
            const fileRemote = new file_remote_1.FileRemote(this.path, this.scene);
            this.script = await fileRemote.getTextContent();
        }
        (0, assert_1.default)(this.script);
        const rs = await this.callFunctionScript(this.script);
        return rs;
    }
}
exports.ExecJs = ExecJs;
//# sourceMappingURL=exec-js.js.map