"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileStore = void 0;
const assert_1 = __importDefault(require("assert"));
const element_shadow_1 = require("../../components/element-shadow");
const file_storage_1 = require("../../libs/storage/file-storage");
class FileStore extends element_shadow_1.ElementShadow {
    $$ignoreEvalProps = ['storage'];
    path;
    initData;
    password;
    storage;
    get data() {
        return this.result;
    }
    constructor(props) {
        super();
        Object.assign(this, props);
    }
    async exec() {
        this.path = this.scene.getPath(this.path || '');
        (0, assert_1.default)(this.path);
        this.storage = new file_storage_1.FileStorage(this.logger, this.path, this.password);
        return this.load();
    }
    load() {
        return this.storage?.load(this.initData);
    }
    save() {
        this.storage?.save(this.data);
    }
}
exports.FileStore = FileStore;
//# sourceMappingURL=file-store.js.map