import { ElementBuilder } from '../element-builder';
import { ElementShadow } from '../element-shadow';
import { Element } from '../element.interface';
import { Group } from '../group/group';
import { GroupItemProps, GroupProps } from '../group/group.props';
import { SceneProps } from './scene.props';
export declare class Scene extends Group<GroupProps, GroupItemProps> {
    path?: string;
    encryptedPath?: string;
    content?: string;
    password?: string;
    curDir: string;
    localVars: Record<string, any>;
    protected isRoot: boolean;
    protected get innerScene(): this;
    get elementBuilder(): ElementBuilder;
    constructor({ path, encryptPath, content, password, ...props }: SceneProps);
    asyncConstructor(): Promise<void>;
    exec(): Promise<ElementShadow[]>;
    dispose(): Promise<void>;
    getPath(p: string): string;
    getVars(str: any, ctx?: Element | ElementShadow | any, others?: any): Promise<any>;
    setVars(varObj: any, vl: any, ctx?: any): Promise<string[] | undefined>;
    mergeVars(obj: any): void;
    private copyVarsToLocal;
    private copyVarsToGlobal;
    private getRemoteFileProps;
    private decryptContent;
    private generateEncryptedFile;
    private loadVars;
    private loadEnv;
}
